package btree.visitor;
import btree.*;

/**
 * Utility container to hold unprocessed data in a RAC.
 * Holds an INEBTree which contains the data to be processed
 * and an index value indicating which data element to retrieve
 * from the INEBTree.   The index value must be a valid value 
 * within the bounds of the INEBTree's data array.
 */
public interface IDataElt extends IRACElt {
  /**
   * Accessor method for the stored INEBTree
   */
  public INEBTree getBTree();
  
  /**
   * Accessor method for the stored index value
   */
  public int getIdx();
}