package btree.visitor;

/**
 * Utility container to hold either unprocessed data or trees.
 * This interface allows abstractly equivalent entities to 
 * be stored in a RAC and thus processed uniformly.
 */
public interface IRACElt {
  
  /** 
   * Accept method of the visitor design pattern
   * @param algo The IRACEltAlgo to execute.
   * @param inp Vararg input parameter for general use
   * @return The result of executing the appropriate case of the algo
   */
  public Object execute(IRACEltAlgo algo, Object... inp); 
}

