package btree.visitor;

/**
 * Visitor to an IRACElt container
 */
public interface IRACEltAlgo {
  /**
   * Case that is called by an IDataElt host
   * @param host The IDataElt host
   * @param inp Vararg input parameters given to the host's execute method.
   * @return The result of running this case.
   */
  public Object dataCase(IDataElt host, Object... inp);
  
  /**
   * Case that is called by an IBTreeElt host
   * @param host The IBTreeElt host
   * @param inp Vararg input parameters given to the host's execute method.
   * @return The result of running this case.
   */
  public Object treeCase(IBTreeElt host, Object... inp);
}