package btree.visitor;
import btree.*;

/**
 * Abstract factory interface to instantiate IRACElt objects.
 */
public interface IRACEltFactory {
  
  /**
   * Instantiates a new IDataElt given an INEBTree and an index value
   * indicating which data element to use.
   * @param host An INEBTree
   * @param idx A valid index value to one of the host's data elements.
   * @return A new IDataElt instance 
   */
  public IDataElt makeDataElt(final INEBTree host, final int idx);
  
  /**
   * Instantiates a new IBTreeElt given an IBTree
   * @param host An IBTree
   * @return A new IBTreeElt instance 
   */  
  public IBTreeElt makeBTreeElt(final IBTree host);
}