package btree.visitor;
import btree.*;
import rac.*;
import util.*;

/**
 * Traverses an IBTree using a given RAC, applying the given ILambda 
 * to every data element in an order determined by the RAC.
 * @param inp   inp[0] = RAC to use, inp[1] = ILambda to use on every data element in a non-empty host
 * @return false if the IBTree host was empty, true otherwise.
 */
public class RACTraverse implements IBTreeAlgo {
  
  /**
   * Singleton design pattern
   */
  public static final RACTraverse Singleton = new RACTraverse();
  private RACTraverse(){}
  
  /**
   * Factory to use for wrapping trees and indices into IRACElts
   */
  private IRACEltFactory fac = RACEltFactory.Singleton;
  
  /**
   * Empty tree, nothing got processed.
   * @return false always.
   */
  public Object mtCase(IMTBTree host, Object...inp) {
    return false;
  }
  
  /**
   * Applyu the given ILambda to every data element in the tree and
   * in every child tree, in the order specified by the RAC.
   * @param inp   inp[0] = RAC to use, inp[1] = ILambda to use on every data element in a non-empty host
   * @return true, always because at least one data element will get processed.
   */
  public Object neCase(INEBTree host, Object...inp){
    // Convenience variables to eliminate excessive casting
    final IRAContainer rac = (IRAContainer) inp[0];
    final ILambda lambda = (ILambda) inp[1];

    // Prob. 1: STUDENT TO COMPLETE
    
    return null;  // STUB CODE
  }
}