package btree.visitor;
import btree.*;
import brs.*;

/**
 * Algo that splits off the first data element and child tree from a B-tree and returns 
 * a B-Tree with the remaining elements and children.
 */
public class SplitAt implements IBTreeAlgo {
  
  public static final SplitAt Singleton = new SplitAt();
  private SplitAt(){}
  
  public Object mtCase(IMTBTree host, Object...idxs) {
    return BTreeFac.Singleton.makeMTBTree();
  }
  
  public Object neCase(INEBTree host, Object...idxs){
    int idx = (Integer) idxs[0];
    Object[] data = host.getData();
    IBTree[] children = host.getChildren();
    
    if(data.length <= idx) return children[children.length-1];
    if(0 > idx) return children[0];
    
    Object[] newData =  new Object[data.length-idx];
    System.arraycopy(data,idx,newData,0, data.length-idx);
    IBTree[] newChildren = new IBTree[children.length-idx];
    System.arraycopy(children,idx,newChildren,0, children.length-idx);
      

    
    return BTreeFac.Singleton.makeNEBTree(newData, newChildren);
  }
  
}