package btree.visitor;
import btree.*;
import brs.*;

/**
 * Convert B-Tree to a Binary Search Tree
 */
public class ToBST implements IBTreeAlgo {
  
  public static final ToBST Singleton = new ToBST();
  private ToBST(){}
  
  public Object mtCase(IMTBTree host, Object...params) {
    return new BiTree();
  }
  
  public Object neCase(INEBTree host, Object...params){
    int count = host.getData().length;
    Object[] data = host.getData();
    IBTree[] children = host.getChildren();
    
    BiTree result = new BiTree();
    result.insertRoot(data[0]);
    result.setLeftSubTree((BiTree)children[0].execute(this));
    result.setRightSubTree((BiTree)children[1].execute(this));
    
    for(int i = 1; i<data.length;i++) {
      BiTree newResult = new BiTree();
      newResult.insertRoot(data[i]);
      newResult.setLeftSubTree(result);
      newResult.setRightSubTree((BiTree)children[i+1].execute(this));
      result = newResult;
    }
    
    return result;
  }
  
}