package btree.visitor.test;
import btree.*;
import btree.visitor.*;
import junit.framework.TestCase;

public class SplitAt_Test extends TestCase {
  
  public void test_splitAt() {
    IBTreeAlgo algo = SplitAt.Singleton;
    IBTreeFac btFac = BTreeFac.Singleton;
    IBTreeAlgo insert = new InsertSearchTree (3, btFac);
    
    IBTree bt = btFac.makeMTBTree();
    IBTree expected = btFac.makeMTBTree();
    IBTree actual = (IBTree) bt.execute(algo, 0);
    
    assertEquals("empty BTree", expected.toString(), actual.toString());
    
    bt = (IBTree) bt.execute(insert, 1);
    actual = (IBTree)  bt.execute(algo, 1);
    
    assertEquals("1-elt BTree", expected.toString(), actual.toString());
    
    actual = (IBTree)  bt.execute(algo, 0);
    
    assertEquals("1-elt BTree", bt.toString(), actual.toString());
    
    bt = (IBTree) bt.execute(insert, 5);
    actual = (IBTree)  bt.execute(algo, 0);
    
    assertEquals("1-elt BTree", bt.toString(), actual.toString());
    
    actual = (IBTree)  bt.execute(algo, 1);
    expected = (IBTree) expected.execute(insert, 5);
    System.out.println("bt = \n"+bt + " actual = \n"+actual);
    
    assertEquals("1-elt BTree", expected.toString(), actual.toString());
    
  }
  
}
