package life.model;

/**
 * Utility class that provides no-op behavior for all 
 * cases, so that any ICellAlgo implementation that is 
 * a sub-class of this ACellAlgo doesn't have to worry 
 * about any cases it is not concerned with.
 * A subclass only needs to override the methods it needs.
 * Note that the default behavior is to return null, so this 
 * class is best suited for situations where all results 
 * are either through mutating an input parameter or via a
 * closure and not via a return value.
 */
public abstract class ACellAlgo implements ICellAlgo {
  
  public Object deadCase(ICell host, Object... nu) {
    return null;
  }
  
  public Object live1Case(ICell host, Object... nu){
    return null;
  }
  
  public Object live2Case(ICell host, Object... nu){
    return null;
  }
  
  
}