package schedule;

import rac.*;
import util.*;
import java.util.*;

/**
 * A task scheduler that will run tasks (ILambdas) in the order as given by a particular comparator.
 * Uses a RAC that determines order on retrieval, not insertion.
 */
public class TaskScheduler {
  
  private IRAContainer rac;
  private ILambda noOp;
  
  /**
   * Constructor for the class
   * @param comp  The comparator to use to determine the order of retrieved tasks
   * @param noOp An ILambda to return in the event that there are no tasks left.
   */
  public TaskScheduler(Comparator comp, ILambda noOp) {   
    this.noOp = noOp;
    //Prob. 3.a: STUDENT TO COMPLETE:  Initialize the rac field. 

    
  }
  
  /**
   * Adds the given task to the schedule, with the given priority
   * and at the current time.
   */
  public void addTask(ILambda task, int priority) {
    rac.put(new TimePriorityCmd(System.nanoTime(), priority, task));
  }
 
  /**
   * Returns the next task to run, or the defined no-op lambda if there are no other tasks.
   */
  public ILambda getNextTask() {
    if(rac.isEmpty()) {
      return noOp;
    }
    else {
      return ((TimePriorityCmd) rac.get()).getTask();
    }
  }
}