package schedule;
import util.*;

/**
 * Container class that holds a time in nanoseconds, a priority as an integer, and
 * a task as an ILambda.
 */
public class TimePriorityCmd {

  /**
   * The task 
   */
  private ILambda task;
  
  /**
   * The priority of the task
   */
  private int priority;
  
  /**
   * The time stamp of the task in nanoseconds
   */
  private long time;
  
  public TimePriorityCmd(long time, int priority, ILambda task) {
    this.task = task;
    this.time = time;
    this.priority = priority;
  }
  
  public int getPriority() {
    return priority;
  }
  
  public long getTime() {
    return time;
  }
  
  public ILambda getTask() {
    return task;
  }
}